--[[
    https://wow.gamepedia.com/API_Frame_SetClampedToScreen
    https://github.com/tomrus88/BlizzardInterfaceCode/blob/master/Interface/FrameXML/GameTooltip.lua#L159-L162
]]

local _, addonTable = ...
local config = addonTable.config

local function setDefaultAnchor(self, parent)
    self:SetOwner(parent, 'ANCHOR_NONE')
    self:ClearAllPoints()

    -- Set custom position
    if config.unlockPosition then
        self:SetPoint(config.point, config.relativeFrame, config.relativePoint, config.offsetX, config.offsetY)
    else
        self:SetPoint('BOTTOMRIGHT', UIParent, 'BOTTOMRIGHT', -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y)
    end

    -- -- Anchor to the mouse cursor
    if config.anchorToCursor and not InCombatLockdown() and
        ( (config.cursorSmartMode and GetMouseFocus() == WorldFrame) or not config.cursorSmartMode ) then

        -- When cursorSmartMode is enabled, the anchorToCursor will be ignored if it is not a WorldFrame
        self:SetOwner(parent, config.cursorAnchorType, config.cursorOffsetX, config.cursorOffsetY)
    end

    -- This will flag the tooltip as having been anchored using the default anchor
    self.default = 1 -- maybe it is no longer needed
end

hooksecurefunc('GameTooltip_SetDefaultAnchor', setDefaultAnchor)